# This version uses new-style automatic setup/destroy/mapping
# Need to change /etc/webiopi

# Imports
import webiopi
#import sys
#import time
#from subprocess import call

# Retrieve GPIO lib
GPIO = webiopi.GPIO

L=4
LD=7
R=8
RD=9

#def camera_start():
#     retcode=call("/usr/share/webiopi/htdocs/app/cambot/stream.sh",shell=True)

#def camera_stop():
#     retcode=call("/usr/share/webiopi/htdocs/app/cambot/stream_stop.sh",shell=True)

# -------------------------------------------------- #
# Macro definition part                              #
# -------------------------------------------------- #
@webiopi.macro
def go_forward():
    GPIO.output(L, GPIO.HIGH)
    GPIO.output(LD, GPIO.HIGH)
    GPIO.output(R, GPIO.HIGH)
    GPIO.output(RD, GPIO.HIGH)

@webiopi.macro
def go_backward():
    GPIO.output(L, GPIO.HIGH)
    GPIO.output(LD, GPIO.LOW)
    GPIO.output(R, GPIO.HIGH)
    GPIO.output(RD, GPIO.LOW)

@webiopi.macro
def turn_left():
    GPIO.output(L, GPIO.HIGH)
    GPIO.output(LD, GPIO.LOW)
    GPIO.output(R, GPIO.HIGH)
    GPIO.output(RD, GPIO.HIGH)

@webiopi.macro
def turn_right():
    GPIO.output(L, GPIO.HIGH)
    GPIO.output(LD, GPIO.HIGH)
    GPIO.output(R, GPIO.HIGH)
    GPIO.output(RD, GPIO.LOW)

@webiopi.macro
def stop():
    GPIO.output(L, GPIO.LOW)
    GPIO.output(LD, GPIO.LOW)
    GPIO.output(R, GPIO.LOW)
    GPIO.output(RD, GPIO.LOW)

# Called by WebIOPi at script loading
def setup():
    # Setup GPIOs
    GPIO.setFunction(L, GPIO.OUT)
    GPIO.setFunction(LD, GPIO.OUT)
    GPIO.setFunction(R, GPIO.OUT)
    GPIO.setFunction(RD, GPIO.OUT)
    stop()
#    camera_start()

# Called by WebIOPi at server shutdown
def destroy():
    # Reset GPIO functions
    GPIO.setFunction(L, GPIO.IN)
    GPIO.setFunction(LD,GPIO.IN)
    GPIO.setFunction(R, GPIO.IN)
    GPIO.setFunction(RD, GPIO.IN)
#    camera_stop()